<?php
namespace Teknisa\PLA\Modules\Mymeals\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Pla02030AprovacaoComensaisController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $Pla02030AprovacaoComensaisService;
    
    public function __construct($crudService,$parameterBag,$Pla02030AprovacaoComensaisService) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->Pla02030AprovacaoComensaisService = $Pla02030AprovacaoComensaisService;
    }
    
    public function insereConfirmarefe(DTO\Request\DataSet $request, DTO\Response $response){
        try{
            $rows = $request->getDataSet()->getRows();
            $this->Pla02030AprovacaoComensaisService->iniciaTransacao();

            foreach ($rows as $row) {
                $this->Pla02030AprovacaoComensaisService->insereConfirmarefe($row);
                $this->Pla02030AprovacaoComensaisService->flush();
            }
            
            $this->Pla02030AprovacaoComensaisService->commit();
        }catch(\Exception $e){
            $this->Pla02030AprovacaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function aprovaCardapio(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        
        $nrorg = $row['NRORG'];
        $cdoperador = $row['CDOPERADOR'];
        $itensSelecionados = $row['ITENSSELECIONADOS'];
        $emailMessages = $row["EMAIL_MENSAGES"];
        $retornoExclusao;
        
        foreach($itensSelecionados as $callback){
            if ($callback['QTCOMEALTERADA'] == 0) {
                try{
                    $retornoExclusao[] = $this->Pla02030AprovacaoComensaisService->excluirCardapio($callback, $emailMessages);
                }catch(\Exception $e) {
                    $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
                }
            } else {
                $cdfilial = $callback['CDFILIAL'];
                $nrconfirmarefe = $callback['NRCONFIRMAREFE'];
                $cdservfili = $callback['CDSERVFILI'];
                $nrcardapio = $callback['NRCARDAPIO'];
                $dtcardapio = $callback['DTCARDAPIO'];
                $idqtdeaprovada = 'PENDENTE';
                $nmfilial = $callback['NMFILIAL'];
                $nmOperadorMymeals = $callback['NMOPERADOR'];
                $CdOperadorMymeals = $callback['CDOPERULTATU'];
                $nmservico = $callback['NMSERVICO'];
                $qtComensaisAlterados = $callback['QTCOMEALTERADA'];
                $qtComensaisOriginal = $callback['QTCOMEORIGINAL'];
                $nrhistoricomymeals = $callback['NRHISTORICOMYMEALS'];
                
                $params = array(
                    "CDFILIAL" => $cdfilial,
                    "CDSERVFILI" => $cdservfili,
                    "NRCARDAPIO" => $nrcardapio,
                    "DTCARDAPIO" => $dtcardapio,
                    "IDQTDEAPROVADA" => $idqtdeaprovada
                );
                
                $altcardapio = $this->Pla02030AprovacaoComensaisService->getAlteracoesCardapio($params);
                $altturnos = $this->Pla02030AprovacaoComensaisService->getAlteracoesTurno($params);
                $carda = $this->Pla02030AprovacaoComensaisService->getCardadiaAprov($params);
                $altpontoentrega = $this->Pla02030AprovacaoComensaisService->getAlteracoesPontoEntrega($params);
    
                $qtestiturno1 = 0;
                $qtestiturno2 = 0;
                $qtestiturno3 = 0;
                $qtestiturno4 = 0;
                $qtfunesticar = 0;
                $qtdoaesticar = 0;
                $qttotalalterada = 0;
                $qtcomealterada = 0;
                $qtcomesticar = $carda->getQtcomesticar();
                $qtcliesticar = $carda->getQtcliesticar();
                $qtfunesticar = $carda->getQtfunesticar();
                $qtdoaesticar = $carda->getQtdoaesticar();
    
                $cdcliente = null;
                $cddestfili = null;
                
                $turnos = array(null,null,null,null);
                
                if(count($altcardapio) > 0){
                    $qtcomealterada = $altcardapio[0]["QTCOMEALTERADA"];
                    $qttotalalterada = $altcardapio[0]["QTTOTALALTERADA"];
                }
                
                if(count($altturnos) > 0){
                    foreach($altturnos as $callback){
                        $turnos[$callback["CDTURNO"]-1] = $callback["QTCOMEALTERADA"];
                    }
                }
                
                if($carda->getNrcardapio()){
                    $qtfunesticar = $carda->getQtfunesticar();
                    $qtdoaesticar = $carda->getQtdoaesticar();
                    $qtestiturno1 = $turnos[0];
                    
                    if(is_null($qtestiturno1)){
                        $qtestiturno1 = $carda->getQtestiturno1();
                        $qtestiturno2 = $carda->getQtestiturno2();
                        $qtestiturno3 = $carda->getQtestiturno3();
                        $qtestiturno4 = $carda->getQtestiturno4();
                    }else{
                        $qtestiturno2 = $turnos[1];
                        $qtestiturno3 = $turnos[2];
                        $qtestiturno4 = $turnos[3];
                    }
                }
                
                $turnosRateio = array(
                    "QTESTITURNO1" => $qtestiturno1,
                    "QTESTITURNO2" => $qtestiturno2,
                    "QTESTITURNO3" => $qtestiturno3,
                    "QTESTITURNO4" => $qtestiturno4,
                );
                $turnosRateioRealizado = $this->realizaRateioTurno($qttotalalterada, $turnosRateio);
    
                $dadosCardadia = array(
                    "NRORG" => $nrorg,
                    "CDFILIAL" => $cdfilial,
                    "NRCARDAPIO" => $nrcardapio,
                    "QTCOMESTICAR" => $qttotalalterada,
                    "QTCLIESTICAR" => $qtcomealterada,
                    "QTFUNESTICAR" => $qtfunesticar,
                    "QTDOAESTICAR" => $qtdoaesticar,
                    "QTFUNESTICAR" => $qtfunesticar,
                    "QTDOAESTICAR" => $qtdoaesticar,
                    "QTESTITURNO1" => $turnosRateioRealizado['QTESTITURNO1'],
                    "QTESTITURNO2" => $turnosRateioRealizado['QTESTITURNO2'],
                    "QTESTITURNO3" => $turnosRateioRealizado['QTESTITURNO3'],
                    "QTESTITURNO4" => $turnosRateioRealizado['QTESTITURNO4'],
                    "CDOPERADOR" => $cdoperador
                );
                
                $dadosCardacli = array(
                    "NRORG" => $nrorg,
                    "NRCARDAPIO" => $nrcardapio,
                    "CDCLIENTE" => $cdcliente,
                    "CDDESTFILI" => $cddestfili,
                    "QTCOMESTICLI" => $qtcomealterada,
                    "CDOPERADOR" => $cdoperador
                );
                
                $dadosAprovaCardapio = array(
                    "NRORG" => $nrorg,
                    "NRCONFIRMAREFE" => $nrconfirmarefe,
                    "CDFILIAL" => $cdfilial,
                    "CDSERVFILI" => $cdservfili,
                    "NRCARDAPIO" => $nrcardapio,
                    "DTCARDAPIO" => $dtcardapio,
                    "IDQTDEAPROVADA" => $idqtdeaprovada,
                    "CDOPERADOR" => $cdoperador,
                    "NRHISTORICOMYMEALS" => $nrhistoricomymeals,
                    "NMFILIAL" => $nmfilial,
                    "NMOPERADOR" => $nmOperadorMymeals,
                    "CDOPERULTATU" => $CdOperadorMymeals,
                    "NMSERVICO" => $nmservico,
                    "QTCOMEALTERADA" => $qtComensaisAlterados,
                    "QTCOMEORIGINAL" => $qtComensaisOriginal
                );
    
                $this->atuComensaisAprovaCardapio($altpontoentrega,$dadosCardadia,$dadosCardacli,$dadosAprovaCardapio,$response);
                $emailMessages["emailDescription"] = str_replace("__TYPE__", "", $emailMessages["emailDescription"]);
                try {
                    $this->Pla02030AprovacaoComensaisService->sendMail($dadosAprovaCardapio, $emailMessages, 'APROVADO');
                }catch (\Exception $e) {
                    $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
                }
            }
            
            $retornoExclusao = !empty($retornoExclusao) ? $retornoExclusao : array();
            $response->addDataSet(new DataSet('retornoExcluirCardapio', $retornoExclusao));
        }
    }
    
    public function realizaRateioTurno($qttotalalterada, $turnosRateio) {
        $comensaisTotal = $qttotalalterada;
        
        $somaArrayTurnosOriginal = array_sum($turnosRateio);
        
        foreach ($turnosRateio as $index => $value) {

            if(!empty($value) && $value != 0) {
                $pesoPorcentagemTurno = ($value / $somaArrayTurnosOriginal) * 100;
                $turnosRateio[$index] = round(($comensaisTotal * $pesoPorcentagemTurno) / 100);
            } else {
                $turnosRateio[$index] = $value;
            }
        }

        $diferenca = round($comensaisTotal - array_sum($turnosRateio));

        if ($diferenca != 0) {
            for ($i = count($turnosRateio) - 1; $i >= 0; $i--) {
                $key = array_keys($turnosRateio)[$i];
                if ($turnosRateio[$key] != 0 && $turnosRateio[$key] !== null && $turnosRateio[$key] + $diferenca >= 0 ) {
                    $turnosRateio[$key] += $diferenca;
                    break;
                }
            }
        }
        return $turnosRateio;
    }
    
    public function reprovaCardapio(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        
        $nrorg = $row['NRORG'];
        $cdoperador = $row['CDOPERADOR'];
        $itensSelecionados = $row['ITENSSELECIONADOS'];
        $justificativa = $row['JUSTIFICATIVA'];
        $emailMessages = $row["EMAIL_MENSAGES"];

        foreach($itensSelecionados as $callback){
            $cdfilial = $callback['CDFILIAL'];
            $nmfilial = $callback['NMFILIAL'];
            $nmOperadorMymeals = $callback['NMOPERADOR'];
            $CdOperadorMymeals = $callback['CDOPERULTATU'];
            $nrconfirmarefe = $callback['NRCONFIRMAREFE'];
            $cdservfili = $callback['CDSERVFILI'];
            $nmservico = $callback['NMSERVICO'];
            $nrcardapio = $callback['NRCARDAPIO'];
            $dtcardapio = $callback['DTCARDAPIO'];
            $idqtdeaprovada = 'PENDENTE';
            $nrhistoricomymeals = $callback['NRHISTORICOMYMEALS'];
            $qtComensaisAlterados = $callback['QTCOMEALTERADA'];
            $qtComensaisOriginal = $callback['QTCOMEORIGINAL'];

            $dadosReprovaCardapio = array(
                "NRORG" => $nrorg,
                "NRCONFIRMAREFE" => $nrconfirmarefe,
                "CDFILIAL" => $cdfilial,
                "NMFILIAL" => $nmfilial,
                "NMOPERADOR" => $nmOperadorMymeals,
                "CDOPERULTATU" => $CdOperadorMymeals,
                "CDSERVFILI" => $cdservfili,
                "NMSERVICO" => $nmservico,
                "NRCARDAPIO" => $nrcardapio,
                "DTCARDAPIO" => $dtcardapio,
                "IDQTDEAPROVADA" => $idqtdeaprovada,
                "CDOPERADOR" => $cdoperador,
                "NRHISTORICOMYMEALS" => $nrhistoricomymeals,
                "JUSTIFICATIVA" => $justificativa,
                "QTCOMEALTERADA" => $qtComensaisAlterados,
                "QTCOMEORIGINAL" => $qtComensaisOriginal
            );

            $this->Pla02030AprovacaoComensaisService->reprovaCardapio($dadosReprovaCardapio);
            $this->Pla02030AprovacaoComensaisService->salvaReprovacaoHistoricoMymeals($dadosReprovaCardapio);
            $this->Pla02030AprovacaoComensaisService->flush();
            $emailMessages["emailDescription"] = str_replace("__TYPE__", "", $emailMessages["emailDescription"]);
            try {
                $this->Pla02030AprovacaoComensaisService->sendMail($dadosReprovaCardapio, $emailMessages,'REPROVADO');
            }catch (\Exception $e) {
                $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
            }
        }
    }
    
    public function atuComensaisAprovaCardapio($altpontoentrega,$dadosCardadia,$dadosCardacli,$dadosAprovaCardapio, DTO\Response $response){

        try{
            $this->Pla02030AprovacaoComensaisService->iniciaTransacao();
            
            $this->Pla02030AprovacaoComensaisService->atualizaCardadia($dadosCardadia);
            $this->Pla02030AprovacaoComensaisService->flush();
            
            if(count($altpontoentrega) > 0){
                foreach($altpontoentrega as $callback) {
                    $dadosCardacli = array(
                        "NRORG" => $dadosCardacli["NRORG"],
                        "NRCARDAPIO" => $callback["NRCARDAPIO"],
                        "CDCLIENTE" => $callback["CDCLIENTE"],
                        "CDDESTFILI" => $callback["CDDESTFILI"],
                        "QTCOMEALTERADA" => $callback["QTCOMEALTERADA"],
                        "CDOPERADOR" => $dadosCardacli["CDOPERADOR"] 
                    );
                    
                    $this->Pla02030AprovacaoComensaisService->atualizaComensaisCardacli($dadosCardacli);
                    $this->Pla02030AprovacaoComensaisService->flush();
                }
            }
            
            $this->Pla02030AprovacaoComensaisService->aprovaCardapio($dadosAprovaCardapio);
            $this->Pla02030AprovacaoComensaisService->salvaAprovacaoHistoricoMymeals($dadosAprovaCardapio);
            $this->Pla02030AprovacaoComensaisService->flush();
            
            $this->Pla02030AprovacaoComensaisService->commit();
            
        }catch(\Exception $e){
            $this->Pla02030AprovacaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function listaCardapio(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_cardapio";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG');

        $this->find($request, $response);
    }
    
    public function listaComensais(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_comensais";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO');
        
        $this->find($request, $response);
    }
    
    public function listaTurnos(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_turno";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO');

        $this->find($request, $response);
    }
    
    public function listaPontoEntrega(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_ponto_entrega";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO');

        $this->find($request, $response);
    }
    
    public function listaPratos(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02030_prato";
        $this->parameterBagColumns = array('CDFILIAL','CDSERVFILI','NRORG','NRCARDAPIO','DTCARDAPIO', 'IDQTDEAPROVADA');

        $this->find($request, $response);
    }
    
    public function verificaEfetivosAprovacaoMymeals(DTO\Request\Row $request, DTO\Response $response){
        $rows = $request->getRow();
        $existeEfetivos = [];
        foreach ($rows as $row) {
           $efetivos = $this->Pla02030AprovacaoComensaisService->verificaEfetivos($row);
           if (!empty($efetivos)) {
               array_push($existeEfetivos, $efetivos);
           }
        }

        $response->addDataSet(new DataSet('existeEfetivos', $existeEfetivos));
    }
    
    public function verificaGridComensais(DTO\Request\Row $request, DTO\Response $response){
        $rows = $request->getRow();
        $rowsAtualizada = [];
        foreach ($rows as &$row) {
           $conditions = [
    			[
    				"columnName"=> "CDFILIAL",
    				"operator"	=> "=",
    				"value" 	=> $row['CDFILIAL']
    			],
    			[
    				"columnName"=> "CDSERVFILI",
    				"operator"	=> "=",
    				"value" 	=> $row['CDSERVFILI']
    			],
    			[
    				"columnName"=> "DTCARDAPIO",
    				"operator"	=> "=",
    				"value" 	=> $row['DTCARDAPIO']
    			],
    			[
    				"columnName"=> "NRCARDAPIO",
    				"operator"	=> "=",
    				"value" 	=> $row['NRCARDAPIO']
    			]
    		];
    		$gridComensais = $this->crudService->getFilteredDataSet("pla02030_comensais", $conditions)->getRows();
    		$row['QTCOMEALTERADA'] = $gridComensais[0]['QTCOMEALTERADA'];
    		array_push($rowsAtualizada, $row);
        }
        $response->addDataSet(new DataSet('itensSelecionadosAtualizado', $rowsAtualizada));
    }
}